Index: src/backend/commands/copy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/copy.c,v
retrieving revision 1.245
diff -c -r1.245 copy.c
*** src/backend/commands/copy.c	2 Jun 2005 01:21:22 -0000	1.245
--- src/backend/commands/copy.c	27 Jun 2005 18:45:39 -0000
***************
*** 1795,1808 ****
  					isnull = false;
  				}
  
! 				/* we read an SQL NULL, no need to do anything */
  				if (!isnull)
  				{
  					copy_attname = NameStr(attr[m]->attname);
  					values[m] = FunctionCall3(&in_functions[m],
  											  CStringGetDatum(string),
! 										ObjectIdGetDatum(typioparams[m]),
! 									  Int32GetDatum(attr[m]->atttypmod));
  					nulls[m] = ' ';
  					copy_attname = NULL;
  				}
--- 2071,2087 ----
  					isnull = false;
  				}
  
! 				/*
! 				 * we read an SQL NULL, no need to do anything
! 				 */
  				if (!isnull)
  				{
  					copy_attname = NameStr(attr[m]->attname);
  					values[m] = FunctionCall3(&in_functions[m],
  											  CStringGetDatum(string),
! 											  ObjectIdGetDatum(typioparams[m]),
! 											  Int32GetDatum(attr[m]->
! 															atttypmod));
  					nulls[m] = ' ';
  					copy_attname = NULL;
  				}
***************
*** 1818,1828 ****
  			if (result == NORMAL_ATTR && line_buf.len != 0)
  				ereport(ERROR,
  						(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 					   errmsg("extra data after last expected column")));
  		}
  		else
  		{
! 			/* binary */
  			int16		fld_count;
  			ListCell   *cur;
  
--- 2097,2109 ----
  			if (result == NORMAL_ATTR && line_buf.len != 0)
  				ereport(ERROR,
  						(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 						 errmsg("extra data after last expected column")));
  		}
  		else
  		{
! 			/*
! 			 * binary
! 			 */
  			int16		fld_count;
  			ListCell   *cur;
  
***************
*** 1844,1851 ****
  				copy_attname = "oid";
  				loaded_oid =
  					DatumGetObjectId(CopyReadBinaryAttribute(0,
! 														&oid_in_function,
! 														  oid_typioparam,
  															 &isnull));
  				if (isnull || loaded_oid == InvalidOid)
  					ereport(ERROR,
--- 2125,2132 ----
  				copy_attname = "oid";
  				loaded_oid =
  					DatumGetObjectId(CopyReadBinaryAttribute(0,
! 															 &oid_in_function,
! 															 oid_typioparam,
  															 &isnull));
  				if (isnull || loaded_oid == InvalidOid)
  					ereport(ERROR,
***************
*** 1864,1871 ****
  				i++;
  				values[m] = CopyReadBinaryAttribute(i,
  													&in_functions[m],
! 													typioparams[m],
! 													&isnull);
  				nulls[m] = isnull ? 'n' : ' ';
  				copy_attname = NULL;
  			}
--- 2145,2151 ----
  				i++;
  				values[m] = CopyReadBinaryAttribute(i,
  													&in_functions[m],
! 													typioparams[m], &isnull);
  				nulls[m] = isnull ? 'n' : ' ';
  				copy_attname = NULL;
  			}
***************
*** 1884,1890 ****
  				nulls[defmap[i]] = ' ';
  		}
  
! 		/* Next apply any domain constraints */
  		if (hasConstraints)
  		{
  			ParamExecData *prmdata = &econtext->ecxt_param_exec_vals[0];
--- 2164,2172 ----
  				nulls[defmap[i]] = ' ';
  		}
  
! 		/*
! 		 * Next apply any domain constraints
! 		 */
  		if (hasConstraints)
  		{
  			ParamExecData *prmdata = &econtext->ecxt_param_exec_vals[0];
***************
*** 1896,1902 ****
  				if (exprstate == NULL)
  					continue;	/* no constraint for this attr */
  
! 				/* Insert current row's value into the Param value */
  				prmdata->value = values[i];
  				prmdata->isnull = (nulls[i] == 'n');
  
--- 2178,2186 ----
  				if (exprstate == NULL)
  					continue;	/* no constraint for this attr */
  
! 				/*
! 				 * Insert current row's value into the Param value 
! 				 */
  				prmdata->value = values[i];
  				prmdata->isnull = (nulls[i] == 'n');
  
***************
*** 1905,1928 ****
  				 * expression to replace the value (consider e.g. a
  				 * timestamp precision restriction).
  				 */
! 				values[i] = ExecEvalExpr(exprstate, econtext,
! 										 &isnull, NULL);
  				nulls[i] = isnull ? 'n' : ' ';
  			}
  		}
  
! 		/* And now we can form the input tuple. */
  		tuple = heap_formtuple(tupDesc, values, nulls);
  
  		if (oids && file_has_oids)
  			HeapTupleSetOid(tuple, loaded_oid);
  
! 		/* Triggers and stuff need to be invoked in query context. */
  		MemoryContextSwitchTo(oldcontext);
  
  		skip_tuple = false;
  
! 		/* BEFORE ROW INSERT Triggers */
  		if (resultRelInfo->ri_TrigDesc &&
  			resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_INSERT] > 0)
  		{
--- 2189,2217 ----
  				 * expression to replace the value (consider e.g. a
  				 * timestamp precision restriction).
  				 */
! 				values[i] = ExecEvalExpr(exprstate, econtext, &isnull, NULL);
  				nulls[i] = isnull ? 'n' : ' ';
  			}
  		}
  
! 		/*
! 		 * And now we can form the input tuple.
! 		 */
  		tuple = heap_formtuple(tupDesc, values, nulls);
  
  		if (oids && file_has_oids)
  			HeapTupleSetOid(tuple, loaded_oid);
  
! 		/*
! 		 * Triggers and stuff need to be invoked in query context.
! 		 */
  		MemoryContextSwitchTo(oldcontext);
  
  		skip_tuple = false;
  
! 		/*
! 		 * BEFORE ROW INSERT Triggers
! 		 */
  		if (resultRelInfo->ri_TrigDesc &&
  			resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_INSERT] > 0)
  		{
***************
*** 1941,1973 ****
  
  		if (!skip_tuple)
  		{
! 			/* Place tuple in tuple slot */
  			ExecStoreTuple(tuple, slot, InvalidBuffer, false);
  
! 			/* Check the constraints of the tuple */
  			if (rel->rd_att->constr)
  				ExecConstraints(resultRelInfo, slot, estate);
  
! 			/* OK, store the tuple and create index entries for it */
  			simple_heap_insert(rel, tuple);
  
  			if (resultRelInfo->ri_NumIndices > 0)
  				ExecInsertIndexTuples(slot, &(tuple->t_self), estate, false);
  
! 			/* AFTER ROW INSERT Triggers */
  			ExecARInsertTriggers(estate, resultRelInfo, tuple);
  		}
  	}
  
! 	/* Done, clean up */
  	error_context_stack = errcontext.previous;
  
  	MemoryContextSwitchTo(oldcontext);
  
! 	/* Execute AFTER STATEMENT insertion triggers */
  	ExecASInsertTriggers(estate, resultRelInfo);
  
! 	/* Handle queued AFTER triggers */
  	AfterTriggerEndQuery(estate);
  
  	pfree(values);
--- 2230,2276 ----
  
  		if (!skip_tuple)
  		{
! 			/*
! 			 * Place tuple in tuple slot
! 			 */
  			ExecStoreTuple(tuple, slot, InvalidBuffer, false);
  
! 			/*
! 			 * Check the constraints of the tuple
! 			 */
  			if (rel->rd_att->constr)
  				ExecConstraints(resultRelInfo, slot, estate);
  
! 			/*
! 			 * OK, store the tuple and create index entries for it
! 			 */
  			simple_heap_insert(rel, tuple);
  
  			if (resultRelInfo->ri_NumIndices > 0)
  				ExecInsertIndexTuples(slot, &(tuple->t_self), estate, false);
  
! 			/*
! 			 * AFTER ROW INSERT Triggers
! 			 */
  			ExecARInsertTriggers(estate, resultRelInfo, tuple);
  		}
  	}
  
! 	/*
! 	 * Done, clean up
! 	 */
  	error_context_stack = errcontext.previous;
  
  	MemoryContextSwitchTo(oldcontext);
  
! 	/*
! 	 * Execute AFTER STATEMENT insertion triggers
! 	 */
  	ExecASInsertTriggers(estate, resultRelInfo);
  
! 	/*
! 	 * Handle queued AFTER triggers
! 	 */
  	AfterTriggerEndQuery(estate);
  
  	pfree(values);
***************
*** 1987,2019 ****
  	FreeExecutorState(estate);
  }
  
- 
  /*
!  * Read the next input line and stash it in line_buf, with conversion to
!  * server encoding.
!  *
!  * Result is true if read was terminated by EOF, false if terminated
!  * by newline.
   */
! static bool
! CopyReadLine(char * quote, char * escape)
  {
! 	bool		result;
! 	bool		change_encoding = (client_encoding != server_encoding);
! 	int			c;
! 	int			mblen;
! 	int			j;
  	unsigned char s[2];
  	char	   *cvt;
! 	bool        in_quote = false, last_was_esc = false, csv_mode = false;
! 	char        quotec = '\0', escapec = '\0';
  
  	if (quote)
  	{
  		csv_mode = true;
  		quotec = quote[0];
  		escapec = escape[0];
! 		/* ignore special escape processing if it's the same as quotec */
  		if (quotec == escapec)
  			escapec = '\0';
  	}
--- 2290,2852 ----
  	FreeExecutorState(estate);
  }
  
  /*
!  * Copy FROM file to relation with faster processing.
   */
! static void
! CopyFromDelimited(Relation rel, List *attnumlist, bool binary, bool oids,
! 				  char *delim, char *null_print, bool csv_mode, char *quote,
! 				  char *escape, List *force_notnull_atts)
  {
! 	HeapTuple	tuple;
! 	TupleDesc	tupDesc;
! 	Form_pg_attribute *attr;
! 	AttrNumber	num_phys_attrs,
! 				attr_count,
! 				num_defaults;
! 	FmgrInfo   *in_functions;
! 	Oid		   *typioparams;
! 	ExprState **constraintexprs;
! 	bool	   *force_notnull;
! 	bool		hasConstraints = false;
! 	int			attnum;
! 	int			i;
! 	Oid			in_func_oid;
! 	Datum	   *values;
! 	char	   *nulls;
! 
! 	/*
! 	 * an array of offsets into attr_buf that point to beginning of attributes
! 	 */
! 	int		   *attr_offsets;
! 	bool		isnull;
! 	int			null_print_len; /* length of null print */
! 	ResultRelInfo *resultRelInfo;
! 	EState	   *estate = CreateExecutorState(); /* for ExecConstraints() */
! 	TupleTableSlot *slot;
! 	bool		file_has_oids;
! 	int		   *defmap;
! 	ExprState **defexprs;		/* array of default att expressions */
! 	ExprContext *econtext;		/* used for ExecEvalExpr for default atts */
! 	MemoryContext oldcontext = CurrentMemoryContext;
! 	ErrorContextCallback errcontext;
! 	bool		no_more_data;
! 	CopyReadResult result;
! 	ListCell   *cur;
! 
! 
! 	tupDesc = RelationGetDescr(rel);
! 	attr = tupDesc->attrs;
! 	num_phys_attrs = tupDesc->natts;
! 	attr_count = list_length(attnumlist);
! 	num_defaults = 0;
! 
! 	/*
! 	 * We need a ResultRelInfo so we can use the regular executor's
! 	 * index-entry-making machinery.  (There used to be a huge amount of
! 	 * code here that basically duplicated execUtils.c ...)
! 	 */
! 	resultRelInfo = makeNode(ResultRelInfo);
! 
! 	resultRelInfo->ri_RangeTableIndex = 1;		/* dummy */
! 	resultRelInfo->ri_RelationDesc = rel;
! 	resultRelInfo->ri_TrigDesc = CopyTriggerDesc(rel->trigdesc);
! 	if (resultRelInfo->ri_TrigDesc)
! 		resultRelInfo->ri_TrigFunctions = (FmgrInfo *)
! 			palloc0(resultRelInfo->ri_TrigDesc->numtriggers *
! 					sizeof(FmgrInfo));
! 	resultRelInfo->ri_TrigInstrument = NULL;
! 
! 	ExecOpenIndices(resultRelInfo);
! 
! 	estate->es_result_relations = resultRelInfo;
! 	estate->es_num_result_relations = 1;
! 	estate->es_result_relation_info = resultRelInfo;
! 
! 	/*
! 	 * Set up a tuple slot too
! 	 */
! 	slot = MakeSingleTupleTableSlot(tupDesc);
! 
! 	econtext = GetPerTupleExprContext(estate);
! 
! 	/*
! 	 * Pick up the required catalog information for each attribute in the
! 	 * relation, including the input function, the element type (to pass
! 	 * to the input function), and info about defaults and constraints.
! 	 * (Which input function we use depends on text/binary format choice.)
! 	 */
! 	in_functions = (FmgrInfo *) palloc(num_phys_attrs * sizeof(FmgrInfo));
! 	typioparams = (Oid *) palloc(num_phys_attrs * sizeof(Oid));
! 	defmap = (int *) palloc(num_phys_attrs * sizeof(int));
! 	defexprs = (ExprState **) palloc(num_phys_attrs * sizeof(ExprState *));
! 	constraintexprs =
! 		(ExprState **) palloc0(num_phys_attrs * sizeof(ExprState *));
! 	force_notnull = (bool *) palloc(num_phys_attrs * sizeof(bool));
! 
! 	for (attnum = 1; attnum <= num_phys_attrs; attnum++)
! 	{
! 		/*
! 		 * We don't need info for dropped attributes 
! 		 */
! 		if (attr[attnum - 1]->attisdropped)
! 			continue;
! 
! 		getTypeInputInfo(attr[attnum - 1]->atttypid,
! 						 &in_func_oid, &typioparams[attnum - 1]);
! 
! 		fmgr_info(in_func_oid, &in_functions[attnum - 1]);
! 
! 		if (list_member_int(force_notnull_atts, attnum))
! 			force_notnull[attnum - 1] = true;
! 		else
! 			force_notnull[attnum - 1] = false;
! 
! 		/*
! 		 * Get default info if needed
! 		 */
! 		if (!list_member_int(attnumlist, attnum))
! 		{
! 			/*
! 			 * attribute is NOT to be copied from input
! 			 */
! 			/*
! 			 * use default value if one exists
! 			 */
! 			Node	   *defexpr = build_column_default(rel, attnum);
! 
! 			if (defexpr != NULL)
! 			{
! 				defexprs[num_defaults] = ExecPrepareExpr((Expr *) defexpr,
! 														 estate);
! 				defmap[num_defaults] = attnum - 1;
! 				num_defaults++;
! 			}
! 		}
! 
! 		/*
! 		 * If it's a domain type, set up to check domain constraints 
! 		 */
! 		if (get_typtype(attr[attnum - 1]->atttypid) == 'd')
! 		{
! 			Param	   *prm;
! 			Node	   *node;
! 
! 			/*
! 			 * Easiest way to do this is to use parse_coerce.c to set up
! 			 * an expression that checks the constraints.  (At present,
! 			 * the expression might contain a length-coercion-function
! 			 * call and/or CoerceToDomain nodes.)  The bottom of the
! 			 * expression is a Param node so that we can fill in the
! 			 * actual datum during the data input loop.
! 			 */
! 			prm = makeNode(Param);
! 
! 			prm->paramkind = PARAM_EXEC;
! 			prm->paramid = 0;
! 			prm->paramtype = getBaseType(attr[attnum - 1]->atttypid);
! 
! 			node = coerce_to_domain((Node *) prm,
! 									prm->paramtype,
! 									attr[attnum - 1]->atttypid,
! 									COERCE_IMPLICIT_CAST, false, false);
! 
! 			constraintexprs[attnum - 1] =
! 				ExecPrepareExpr((Expr *) node, estate);
! 			hasConstraints = true;
! 		}
! 	}
! 
! 	/*
! 	 * Prepare to catch AFTER triggers.
! 	 */
! 	AfterTriggerBeginQuery();
! 
! 	/*
! 	 * Check BEFORE STATEMENT insertion triggers. It's debateable whether
! 	 * we should do this for COPY, since it's not really an "INSERT"
! 	 * statement as such. However, executing these triggers maintains
! 	 * consistency with the EACH ROW triggers that we already fire on
! 	 * COPY.
! 	 */
! 	ExecBSInsertTriggers(estate, resultRelInfo);
! 
! 	file_has_oids = oids;		/* must rely on user to tell us this... */
! 
! 	values = (Datum *) palloc(num_phys_attrs * sizeof(Datum));
! 	nulls = (char *) palloc(num_phys_attrs * sizeof(char));
! 	attr_offsets = (int *) palloc(num_phys_attrs * sizeof(int));
! 
! 	/*
! 	 * Make room for a PARAM_EXEC value for domain constraint checks
! 	 */
! 	if (hasConstraints)
! 		econtext->ecxt_param_exec_vals = (ParamExecData *)
! 			palloc0(sizeof(ParamExecData));
! 
! 	/*
! 	 * Initialize static variables
! 	 */
! 	fe_eof = false;
! 	eol_type = EOL_UNKNOWN;
! 	copy_binary = binary;
! 	copy_relname = RelationGetRelationName(rel);
! 	copy_lineno = 0;
! 	copy_attname = NULL;
! 	line_buf_converted = false;
! 
! 	/*
! 	 * it is MUCH faster to do this once here than in the attribute parse loop
! 	 */
! 	null_print_len = strlen(null_print);
! 
! 	/*
! 	 * Set up callback to identify error line number
! 	 */
! 	errcontext.callback = copy_in_error_callback;
! 	errcontext.arg = NULL;
! 	errcontext.previous = error_context_stack;
! 	error_context_stack = &errcontext;
! 
! 	/*
! 	 * Set up data buffer to hold a chunk of data
! 	 */
! 	MemSet(input_buf, ' ', COPY_BUF_SIZE * sizeof(char));
! 	input_buf[COPY_BUF_SIZE] = '\0';
! 
! 	no_more_data = false;		/* no more input data to read from file or FE */
! 	line_done = true;
! 
! 	do
! 	{
! 		/*
! 		 * read a chunk of data into the buffer
! 		 */
! 		size_t		bytesread = CopyGetData(input_buf, COPY_BUF_SIZE);
! 
! 		buf_done = false;
! 
! 		/*
! 		 * set buffer pointers to beginning of the buffer
! 		 */
! 		begloc = input_buf;
! 		buffer_index = 0;
! 
! 		/*
! 		 * continue if some bytes were read or if we didn't reach EOF. if we both *
! 		 * * reached EOF _and_ no bytes were read, quit the loop we are done
! 		 */
! 		if (bytesread > 0 || !fe_eof)
! 		{
! 
! 			while (!buf_done)
! 			{
! 				bool		skip_tuple;
! 				Oid			loaded_oid = InvalidOid;
! 
! 				CHECK_FOR_INTERRUPTS();
! 
! 				/*
! 				 * Reset the per-tuple exprcontext
! 				 */
! 				ResetPerTupleExprContext(estate);
! 
! 				/*
! 				 * Switch into its memory context
! 				 */
! 				MemoryContextSwitchTo(GetPerTupleMemoryContext(estate));
! 
! 				/*
! 				 * Initialize all values for row to NULL
! 				 */
! 				MemSet(values, 0, num_phys_attrs * sizeof(Datum));
! 				MemSet(nulls, 'n', num_phys_attrs * sizeof(char));
! 				/*
! 				 * reset attribute pointers
! 				 */
! 				MemSet(attr_offsets, 0, num_phys_attrs * sizeof(int));
! 
! 				result = NORMAL_ATTR;
! 
! 				/*
! 				 * Actually read the line into memory here
! 				 */
! 				line_done = CopyReadLineBuffered(bytesread);
! 				copy_lineno++;
! 
! 				/*
! 				 * if didn't finish processing data line, skip att parsing and read more data,
! 				 * * unless there is no more data to read... (which means that the original last
! 				 * * data line is missing attrs and we want to catch that error)
! 				 */
! 				if (!line_done)
! 				{
! 					copy_lineno--;
! 					if (!fe_eof || buf_done)
! 						break;
! 				}
! 
! 				if (file_has_oids)
! 				{
! 					char	   *oid_string;
! 
! 					/*
! 					 * can't be in CSV mode here 
! 					 */
! 					oid_string =
! 						CopyReadOidAttr(delim, null_print, null_print_len,
! 										&result, &isnull);
! 
! 					if (isnull)
! 						ereport(ERROR,
! 								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 								 errmsg("null OID in COPY data")));
! 					else
! 					{
! 						copy_attname = "oid";
! 						loaded_oid =
! 							DatumGetObjectId(DirectFunctionCall1
! 											 (oidin,
! 											  CStringGetDatum(oid_string)));
! 						if (loaded_oid == InvalidOid)
! 							ereport(ERROR,
! 									(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 									 errmsg("invalid OID in COPY data")));
! 						copy_attname = NULL;
! 					}
! 				}
! 
! 				/*
! 				 * parse all the attribute in the data line
! 				 */
! 				CopyReadAllAttrs(delim, null_print, null_print_len,
! 								 nulls, attnumlist, attr_offsets,
! 								 num_phys_attrs, attr);
! 
! 				/*
! 				 * Loop to read the user attributes on the line.
! 				 */
! 				foreach(cur, attnumlist)
! 				{
! 					int			attnum = lfirst_int(cur);
! 					int			m = attnum - 1;
! 
! 					if (nulls[m] == ' ')
! 						isnull = false;
! 					else
! 						isnull = true;
! 
! 					/*
! 					 * we read an SQL NULL, no need to do anything
! 					 */
! 					if (!isnull)
! 					{
! 						copy_attname = NameStr(attr[m]->attname);
! 						values[m] = FunctionCall3(&in_functions[m],
! 												  CStringGetDatum(attr_buf.
! 																  data +
! 																  attr_offsets
! 																  [m]),
! 												  ObjectIdGetDatum(typioparams
! 																   [m]),
! 												  Int32GetDatum(attr[m]->
! 																atttypmod));
! 						copy_attname = NULL;
! 					}
! 				}
! 
! 				/*
! 				 * Now compute and insert any defaults available for the columns
! 				 * not provided by the input data.	Anything not processed here or
! 				 * above will remain NULL.
! 				 */
! 				for (i = 0; i < num_defaults; i++)
! 				{
! 					values[defmap[i]] =
! 						ExecEvalExpr(defexprs[i], econtext, &isnull, NULL);
! 					if (!isnull)
! 						nulls[defmap[i]] = ' ';
! 				}
! 
! 				/*
! 				 * Next apply any domain constraints
! 				 */
! 				if (hasConstraints)
! 				{
! 					ParamExecData *prmdata =
! 						&econtext->ecxt_param_exec_vals[0];
! 
! 					for (i = 0; i < num_phys_attrs; i++)
! 					{
! 						ExprState  *exprstate = constraintexprs[i];
! 
! 						if (exprstate == NULL)
! 							continue;	/* no constraint for this attr */
! 
! 						/*
! 						 * Insert current row's value into the Param value 
! 						 */
! 						prmdata->value = values[i];
! 						prmdata->isnull = (nulls[i] == 'n');
! 
! 						/*
! 						 * Execute the constraint expression.  Allow the
! 						 * expression to replace the value (consider e.g. a
! 						 * timestamp precision restriction).
! 						 */
! 						values[i] = ExecEvalExpr(exprstate, econtext,
! 												 &isnull, NULL);
! 						nulls[i] = isnull ? 'n' : ' ';
! 					}
! 				}
! 
! 				/*
! 				 * And now we can form the input tuple.
! 				 */
! 				tuple = heap_formtuple(tupDesc, values, nulls);
! 
! 				if (oids && file_has_oids)
! 					HeapTupleSetOid(tuple, loaded_oid);
! 
! 				/*
! 				 * Triggers and stuff need to be invoked in query context.
! 				 */
! 				MemoryContextSwitchTo(oldcontext);
! 
! 				skip_tuple = false;
! 
! 				/*
! 				 * BEFORE ROW INSERT Triggers
! 				 */
! 				if (resultRelInfo->ri_TrigDesc &&
! 					resultRelInfo->ri_TrigDesc->
! 					n_before_row[TRIGGER_EVENT_INSERT] > 0)
! 				{
! 					HeapTuple	newtuple;
! 
! 					newtuple =
! 						ExecBRInsertTriggers(estate, resultRelInfo, tuple);
! 
! 					if (newtuple == NULL)		/* "do nothing" */
! 						skip_tuple = true;
! 					else if (newtuple != tuple) /* modified by Trigger(s) */
! 					{
! 						heap_freetuple(tuple);
! 						tuple = newtuple;
! 					}
! 				}
! 
! 				if (!skip_tuple)
! 				{
! 					/*
! 					 * Place tuple in tuple slot
! 					 */
! 					ExecStoreTuple(tuple, slot, InvalidBuffer, false);
! 
! 					/*
! 					 * Check the constraints of the tuple
! 					 */
! 					if (rel->rd_att->constr)
! 						ExecConstraints(resultRelInfo, slot, estate);
! 
! 					/*
! 					 * OK, store the tuple and create index entries for it
! 					 */
! 					simple_heap_insert(rel, tuple);
! 
! 					if (resultRelInfo->ri_NumIndices > 0)
! 						ExecInsertIndexTuples(slot, &(tuple->t_self), estate,
! 											  false);
! 
! 					/*
! 					 * AFTER ROW INSERT Triggers
! 					 */
! 					ExecARInsertTriggers(estate, resultRelInfo, tuple);
! 				}
! 
! 				line_buf.len = 0;		/* we can reset line buffer now. */
! 				line_buf.data[0] = '\0';
! 				line_buf.cursor = 0;
! 			}					/* end while(!buf_done) */
! 		}						/* end if (bytesread > 0 || !fe_eof) */
! 		else
! 			/*
! 			 * no bytes read, end of data
! 			 */
! 		{
! 			no_more_data = TRUE;
! 		}
! 	}
! 	while (!no_more_data);
! 
! 	/*
! 	 * Done, clean up
! 	 */
! 	error_context_stack = errcontext.previous;
! 
! 	MemoryContextSwitchTo(oldcontext);
! 
! 	/*
! 	 * Execute AFTER STATEMENT insertion triggers
! 	 */
! 	ExecASInsertTriggers(estate, resultRelInfo);
! 
! 	/*
! 	 * Handle queued AFTER triggers
! 	 */
! 	AfterTriggerEndQuery(estate);
! 
! 	pfree(values);
! 	pfree(nulls);
! 
! 	pfree(attr_offsets);
! 
! 	pfree(in_functions);
! 	pfree(typioparams);
! 	pfree(defmap);
! 	pfree(defexprs);
! 	pfree(constraintexprs);
! 	pfree(force_notnull);
! 
! 	ExecDropSingleTupleTableSlot(slot);
! 
! 	ExecCloseIndices(resultRelInfo);
! 
! 	FreeExecutorState(estate);
! }
! 
! 
! /*
!  * Read the next input line and stash it in line_buf, with conversion to
!  * server encoding.
!  *
!  * Result is true if read was terminated by EOF, false if terminated
!  * by newline.
!  */
! static bool
! CopyReadLine(char *quote, char *escape)
! {
! 	bool		result;
! 	bool		change_encoding = (client_encoding != server_encoding);
! 	int			c;
! 	int			mblen;
! 	int			j;
  	unsigned char s[2];
  	char	   *cvt;
! 	bool		in_quote = false,
! 		last_was_esc = false,
! 		csv_mode = false;
! 	char		quotec = '\0',
! 		escapec = '\0';
  
  	if (quote)
  	{
  		csv_mode = true;
  		quotec = quote[0];
  		escapec = escape[0];
! 		/*
! 		 * ignore special escape processing if it's the same as quotec 
! 		 */
  		if (quotec == escapec)
  			escapec = '\0';
  	}
***************
*** 2021,2051 ****
  
  	s[1] = 0;
  
! 	/* reset line_buf to empty */
  	line_buf.len = 0;
  	line_buf.data[0] = '\0';
  	line_buf.cursor = 0;
  
! 	/* mark that encoding conversion hasn't occurred yet */
  	line_buf_converted = false;
  
! 	/* set default status */
  	result = false;
  
  	/*
  	 * In this loop we only care for detecting newlines (\r and/or \n) and
! 	 * the end-of-copy marker (\.).  
  	 *
  	 * In Text mode, for backwards compatibility we allow
  	 * backslashes to escape newline characters.  Backslashes other than
  	 * the end marker get put into the line_buf, since CopyReadAttribute
! 	 * does its own escape processing.	
  	 *
  	 * In CSV mode, CR and NL inside q quoted field are just part of the
  	 * data value and are put in line_buf. We keep just enough state
  	 * to know if we are currently in a quoted field or not.
  	 *
! 	 * These four characters, and only these four, are assumed the same in 
  	 * frontend and backend encodings.
  	 *
  	 * We do not assume that second and later bytes of a frontend
--- 2854,2890 ----
  
  	s[1] = 0;
  
! 	/*
! 	 * reset line_buf to empty
! 	 */
  	line_buf.len = 0;
  	line_buf.data[0] = '\0';
  	line_buf.cursor = 0;
  
! 	/*
! 	 * mark that encoding conversion hasn't occurred yet 
! 	 */
  	line_buf_converted = false;
  
! 	/*
! 	 * set default status
! 	 */
  	result = false;
  
  	/*
  	 * In this loop we only care for detecting newlines (\r and/or \n) and
! 	 * the end-of-copy marker (\.).
  	 *
  	 * In Text mode, for backwards compatibility we allow
  	 * backslashes to escape newline characters.  Backslashes other than
  	 * the end marker get put into the line_buf, since CopyReadAttribute
! 	 * does its own escape processing.
  	 *
  	 * In CSV mode, CR and NL inside q quoted field are just part of the
  	 * data value and are put in line_buf. We keep just enough state
  	 * to know if we are currently in a quoted field or not.
  	 *
! 	 * These four characters, and only these four, are assumed the same in
  	 * frontend and backend encodings.
  	 *
  	 * We do not assume that second and later bytes of a frontend
***************
*** 2062,2108 ****
  
  		if (csv_mode)
  		{
! 			/*  
  			 * Dealing with quotes and escapes here is mildly tricky. If the
  			 * quote char is also the escape char, there's no problem - we  
  			 * just use the char as a toggle. If they are different, we need
  			 * to ensure that we only take account of an escape inside a quoted
  			 * field and immediately preceding a quote char, and not the
  			 * second in a escape-escape sequence.
! 			 */ 
  
  			if (in_quote && c == escapec)
! 				last_was_esc = ! last_was_esc;
! 			if (c == quotec && ! last_was_esc)
! 				in_quote = ! in_quote;
  			if (c != escapec)
  				last_was_esc = false;
  
  			/*
! 			 * updating the line count for embedded CR and/or LF chars is 
! 			 * necessarily a little fragile - this test is probably about 
  			 * the best we can do.
! 			 */ 
! 			if (in_quote && c == (eol_type == EOL_CR ? '\r' : '\n')) 
! 				copy_lineno++; 
  		}
  
  		if (!in_quote && c == '\r')
  		{
  			if (eol_type == EOL_NL)
  			{
! 				if (! csv_mode)
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  							 errmsg("literal carriage return found in data"),
! 							 errhint("Use \"\\r\" to represent carriage return.")));
  				else
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 							 errmsg("unquoted carriage return found in CSV data"),
! 							 errhint("Use quoted CSV field to represent carriage return.")));
  			}
! 			/* Check for \r\n on first line, _and_ handle \r\n. */
  			if (eol_type == EOL_UNKNOWN || eol_type == EOL_CRNL)
  			{
  				int			c2 = CopyPeekChar();
--- 2901,2952 ----
  
  		if (csv_mode)
  		{
! 			/*
  			 * Dealing with quotes and escapes here is mildly tricky. If the
  			 * quote char is also the escape char, there's no problem - we  
  			 * just use the char as a toggle. If they are different, we need
  			 * to ensure that we only take account of an escape inside a quoted
  			 * field and immediately preceding a quote char, and not the
  			 * second in a escape-escape sequence.
! 			 */
  
  			if (in_quote && c == escapec)
! 				last_was_esc = !last_was_esc;
! 			if (c == quotec && !last_was_esc)
! 				in_quote = !in_quote;
  			if (c != escapec)
  				last_was_esc = false;
  
  			/*
! 			 * updating the line count for embedded CR and/or LF chars is
! 			 * necessarily a little fragile - this test is probably about
  			 * the best we can do.
! 			 */
! 			if (in_quote && c == (eol_type == EOL_CR ? '\r' : '\n'))
! 				copy_lineno++;
  		}
  
  		if (!in_quote && c == '\r')
  		{
  			if (eol_type == EOL_NL)
  			{
! 				if (!csv_mode)
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  							 errmsg("literal carriage return found in data"),
! 							 errhint
! 							 ("Use \"\\r\" to represent carriage return.")));
  				else
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 							 errmsg
! 							 ("unquoted carriage return found in CSV data"),
! 							 errhint
! 							 ("Use quoted CSV field to represent carriage return.")));
  			}
! 			/*
! 			 * Check for \r\n on first line, _and_ handle \r\n.
! 			 */
  			if (eol_type == EOL_UNKNOWN || eol_type == EOL_CRNL)
  			{
  				int			c2 = CopyPeekChar();
***************
*** 2114,2132 ****
  				}
  				else
  				{
! 					/* found \r, but no \n */
  					if (eol_type == EOL_CRNL)
  					{
  						if (!csv_mode)
  							ereport(ERROR,
  									(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 									 errmsg("literal carriage return found in data"),
! 									 errhint("Use \"\\r\" to represent carriage return.")));
  						else
  							ereport(ERROR,
  									(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 									 errmsg("unquoted carriage return found in data"),
! 									 errhint("Use quoted CSV field to represent carriage return.")));
  
  					}
  
--- 2958,2982 ----
  				}
  				else
  				{
! 					/*
! 					 * found \r, but no \n
! 					 */
  					if (eol_type == EOL_CRNL)
  					{
  						if (!csv_mode)
  							ereport(ERROR,
  									(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 									 errmsg
! 									 ("literal carriage return found in data"),
! 									 errhint
! 									 ("Use \"\\r\" to represent carriage return.")));
  						else
  							ereport(ERROR,
  									(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 									 errmsg
! 									 ("unquoted carriage return found in data"),
! 									 errhint
! 									 ("Use quoted CSV field to represent carriage return.")));
  
  					}
  
***************
*** 2153,2160 ****
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  							 errmsg("unquoted newline found in data"),
! 							 errhint("Use quoted CSV field to represent newline.")));
! 					
  			}
  			eol_type = EOL_NL;
  			break;
--- 3003,3011 ----
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  							 errmsg("unquoted newline found in data"),
! 							 errhint
! 							 ("Use quoted CSV field to represent newline.")));
! 
  			}
  			eol_type = EOL_NL;
  			break;
***************
*** 2162,2169 ****
  
  		if ((line_buf.len == 0 || !csv_mode) && c == '\\')
  		{
! 			int c2;
! 			
  			if (csv_mode)
  				c2 = CopyPeekChar();
  			else
--- 3013,3020 ----
  
  		if ((line_buf.len == 0 || !csv_mode) && c == '\\')
  		{
! 			int			c2;
! 
  			if (csv_mode)
  				c2 = CopyPeekChar();
  			else
***************
*** 2179,2185 ****
  			if (c2 == '.')
  			{
  				if (csv_mode)
! 					CopyDonePeek(c2, true); /* allow keep calling GetChar() */
  
  				if (eol_type == EOL_CRNL)
  				{
--- 3030,3036 ----
  			if (c2 == '.')
  			{
  				if (csv_mode)
! 					CopyDonePeek(c2, true);		/* allow keep calling GetChar() */
  
  				if (eol_type == EOL_CRNL)
  				{
***************
*** 2187,2193 ****
  					if (c == '\n')
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 								 errmsg("end-of-copy marker does not match previous newline style")));
  					if (c != '\r')
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
--- 3038,3045 ----
  					if (c == '\n')
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 								 errmsg
! 								 ("end-of-copy marker does not match previous newline style")));
  					if (c != '\r')
  						ereport(ERROR,
  								(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
